# pe_console_letsencrypt


## Table of Contents

1. [Description](#description)
1. [Setup - The basics of getting started with pe_console_letsencrypt](#setup)
    * [What pe_console_letsencrypt affects](#what-pe_console_letsencrypt-affects)
    * [Setup requirements](#setup-requirements)
    * [Beginning with pe_console_letsencrypt](#beginning-with-pe_console_letsencrypt)
1. [Usage - Configuration options and additional functionality](#usage)
1. [Limitations - OS compatibility, etc.](#limitations)
1. [Development - Guide for contributing to the module](#development)

## Description

Managing the Puppet [console's SSL certificates](https://www.puppet.com/docs/pe/latest/use_a_custom_ssl_cert_for_the_console.html) can be automated, but it's not straightforward if you want them to be managed by [Let's Encrypt](https://letsencrypt.org).

This module will allow you request, install, and manage valid SSL certs for your console, via [Let's Encrypt](https://letsencrypt.org).

It does require that port 80 on your puppet server is accessible from the internet, and that your puppet servers has a publicly resolvable DNS name.

## Setup

### What pe_console_letsencrypt affects

The module will replace the autogenerated, self-signed, SSL certificates used by default.  These certs are usually found in `/etc/puppetlabs/puppet/ssl`.

It uses the [letsencrypt](https://forge.puppet.com/modules/puppet/letsencrypt/readme) module from [Vox Pupuli](https://voxpupuli.org) to do the hard lifting.

### Setup Requirements

You **MUST** disable the default `http_redirect` vhost which is created as part of a PE install.  This can be done by setting the following value in the puppet server's hiera:
`puppet_enterprise::profile::console::proxy::http_redirect::enable_http_redirect: false`

The value can also be set in the Puppet console by adding it as "Configuration data" against the `PE Console` node group.

The module will check that it is disabled and will cause a catalog compilation failure if it isn't.

You should also ensure you're not specifying any certificates in `hiera`.  Check the key `puppet_enterprise::profile::console` for any values matching `browser_ssl_cert` and `browser_ssl_private_key`.

### Beginning with pe_console_letsencrypt

## Usage

At the very basic level, you can simply:
* Add the module and dependencies to your `Puppetfile`
* Add the following hiera to `common.yaml` : `puppet_enterprise::profile::console::proxy::http_redirect::enable_http_redirect: false`
* Classify your puppet server with : `pe_console_letsencrypt`

## Limitations

Only works with Puppet Enterprise

## Development

Fork, develop, submit a pull request

Please make sure all pull requests include testing and that the tests pass
